#include "dialogimpl.h"
//
DialogImpl::DialogImpl( QWidget * parent, Qt::WFlags f) 
	: QDialog(parent, f)
{    count=0;
	
	setupUi(this);	
	buf1=1;
	buf2=1000000;
	x1=0;y1=0;x2=0;y2=50;
	
	connect(bstart, SIGNAL(clicked()), this, SLOT(addClick()));
	connect(bstop, SIGNAL(clicked()), this, SLOT(addShut()));
	connect(bexit, SIGNAL(clicked()), this, SLOT(addExit()));
	connect(bmap, SIGNAL(clicked()), this, SLOT(addMap()));
	connect(&threadA, SIGNAL(conok()), this, SLOT(chgconok()));
	connect(&threadA, SIGNAL(concut()), this, SLOT(chgconcut()));
	
	 sysv=system("touch spdchk.ld");
	 sysv=system("touch chklog.txt");
	 //
	 
	 gView->setScene(&scene);
	 mfont=QFont ();
	 mfont.setPointSize(8);
	
	//line2=QLineF(0,100,250,100 ); 
	 gView->setAlignment((Qt::AlignLeft | Qt::AlignBottom));
	 scene.setSceneRect(0,0,160,50);	 
	 //QRadialGradient gradient(0, 0, 10);
    // gradient.setSpread(QGradient::RepeatSpread);
    gviewshow();
     
	 
	
}
//
void DialogImpl::addClick()
{
 count=0;
 if(!threadA.isRunning())
 {
  if(comboBox->currentIndex()==0)
    {
  	  threadA.conflag=true;
 	}
  else
   {
  	threadA.conflag=false;
 	}
 	if(cbspeed->isChecked())
    {
  	  threadA.speedflag=true;
 	}
  else
   {
  	threadA.speedflag=false;
 	}
  threadA.interval=sbinterval->value();	
  tedit->setText("Checking connection");
  
  threadA.start();
  lcpstatus->setText("Started");
  bstart->setEnabled(false);
  bstop->setEnabled(true);
  tab_2->setDisabled(true); 
  
 }
 
}


void DialogImpl::addShut()
{ 

 tedit->setText("Checkcon stopped!");
 lcpstatus->setText("Stopped"); 
 threadA.terminate();
 threadA.wait();
 sthread.terminate();
	sthread.wait();
 bstart->setEnabled(true);
 bstop->setEnabled(false);
  tab_2->setEnabled(true); 
 
}
void DialogImpl::addMap()
{
	if(cbnetmap->isChecked())
	sysv=system("xterm -bg white -fg brown -title 'Net Map' -e 'watch --no-title netstat -p -t -n'");
	else
	sysv=system("xterm -bg white -fg brown -title 'Net Map' -e 'watch --no-title netstat -p -n'");
		

}

void DialogImpl::addExit()
{
   
    threadA.terminate();
 
    threadA.wait();
    sthread.terminate();
	sthread.wait();
	sysv=system("rm -f spdchk.ld");
	
   
    exit(0);
 
}
void DialogImpl::chgconok()
{	
	if(sthread.isRunning())
		{
			sthread.terminate();
	       sthread.wait();
         }
         lstatus->setText("Connected");
	count=count+threadA.interval;
	tedit->setText("Connection OK!");
	//
	QPen pen(Qt::green,1);
    line3=QLineF(x1,y1,x2,y2 ); 
    
    gView->show();
    if(x1>=138)
    {
    	x1=0;
    	scene.clear();
    	gviewshow();
   	}
    x1=x1+1;
    x2=x1;
    y1=2*(25-((cspeed/8)%25));
    scene.addLine(line3,pen);
			
	//sprintf(countstr,"The system is going down in %ds",count);
	countstr=QString("%1h:%2m:%3s")
             .arg((count/3600), 0, 10)
             .arg(((count/60)%60), 0, 10)
             .arg((count%60), 0, 10);
	 //
	   sysv=system("(pppstats -a |grep 0)>spdchk.ld");
	   f.open("spdchk.ld",ios::in|ios::out);
	   if(f.fail())
	  {cout<<"Error::cant find spdchk.ld file"; }
          f.getline(buf,20,'\0');	   
	   f.close();
	   buf1=atoi(buf);
	   cspeed=((buf1-buf2)*8)/(threadA.interval*1024);
	   
	   
	   lcdnum->display(cspeed);
	   buf2=buf1;
	   
	   lvdown=buf1;
	   vdown=lvdown/(1024*1024);
	   
	   ldown->setText((QString::number(vdown,'f',2)).append(" MB"));
    
	lcount->setText(countstr);
	
}
void DialogImpl::chgconcut()
{    
	gviewshow();		
	lstatus->setText("Terminated");
	tedit->setText("Connection Terminated!");
	
	//bstart->setEnabled(true);
	if(cbmusic->isChecked())
		{
			sysv=system("xterm -e 'play audio.wav'");			
			
		}
	if(cbshut->isChecked())
		
	{   tedit->append("Checkcon stopped for shutdown!");
	    threadA.terminate();
	     threadA.wait();
	     lcpstatus->setText("Stopped");	     
	    
	//
	    tedit->append("Saving to log chklog.txt");
	 
   QFile file("chklog.txt");
     if (!file.open(QIODevice::WriteOnly | QIODevice::Text))
      cerr<<"\ncan't find file chklog.txt\n";
     QTextStream out(&file);
     out << "The last connection lasted: "<<count<<"secs\n";
     file.close();
	// 
	
	sthread.shuttime=spinBox->value();
	sstr=QString("The System is going down in %1 second.!!!")
             .arg(sthread.shuttime, 0, 10);
	tedit->append(sstr);
	tedit->append("Check Terminal for countdown.");
	tedit->append("Press 'stop' to cancel."); 
	
	sthread.start();
	//scount=sthread.shuttime; 
		
	}
	 cbmusic->setChecked(false);
	 bstop->setEnabled(true);
			
}
void DialogImpl::gviewshow()
{	 QPen pen(Qt::gray,1);
	 pen.setStyle(Qt::DotLine);
	 pen.setCapStyle(Qt::RoundCap);
	 line1=QLineF(0,13.5,180,13.5 );
	  scene.addLine(line1,pen);	
	  line4=QLineF(0,25.5,180,25.5 );
	  scene.addLine(line4,pen);	
	  line5=QLineF(0,37.5,180,37.5);
	  scene.addLine(line5,pen);	
	  //scene.addText((QString::number((cspeed/8),'f',0)).append("KB/s"),mfont);
	 QRadialGradient gradient(100, 100, 150, 50, 50);
     gradient.setColorAt(0, QColor::fromRgbF(0, 0, 0, 1));
     gradient.setColorAt(1, QColor::fromRgbF(0, 0, 0, 0));
     gradient.setCenter(0,0);

     scene.setBackgroundBrush(gradient);
     scene.setForegroundBrush(QBrush(Qt::gray, Qt::Dense6Pattern));   
     
	 gView->show();
}
void DialogImpl::closeEvent(QCloseEvent *event)
{
    threadA.stop();    
    threadA.wait();
    sthread.terminate();
    sthread.wait();  
    event->accept();     
    sysv=system("rm -f spdchk.ld");    
    
}


